<?php

/**
 * Helper to implementation of hook_ctools_plugin_api().
 */
function _feedapi_data_test_ctools_plugin_api() {
  $args = func_get_args();
  $module = array_shift($args);
  $api = array_shift($args);
  if ($module == "data" && $api == "data_default") {
    return array("version" => 1);
  }
  else if ($module == "feedapi_mapper" && $api == "feedapi_mapper_default") {
    return array("version" => 1);
  }
}

/**
 * Helper to implementation of hook_data_default().
 */
function _feedapi_data_test_data_default() {
  $export = array();
  $data_table = new stdClass;
  $data_table->disabled = FALSE; /* Edit this to true to make a default data_table disabled initially */
  $data_table->api_version = 1;
  $data_table->title = 'data_feed';
  $data_table->name = 'data_table_feedapi_data_feed';
  $data_table->table_schema = array(
    'fields' => array(
      'feed_nid' => array(
        'type' => 'int',
        'unsigned' => TRUE,
        'not null' => TRUE,
      ),
      'id' => array(
        'type' => 'serial',
        'size' => 'normal',
        'unsigned' => TRUE,
        'not null' => TRUE,
      ),
      'timestamp' => array(
        'description' => 'The Unix timestamp for the data.',
        'type' => 'int',
        'unsigned' => TRUE,
        'not null' => FALSE,
      ),
      'title' => array(
        'type' => 'varchar',
        'length' => 255,
        'not null' => FALSE,
      ),
      'description' => array(
        'type' => 'text',
        'not null' => FALSE,
      ),
      'options_original_url' => array(
        'type' => 'text',
        'not null' => FALSE,
      ),
    ),
    'indexes' => array(
      'feed_nid' => array(
        '0' => 'feed_nid',
      ),
      'id' => array(
        '0' => 'id',
      ),
      'timestamp' => array(
        '0' => 'timestamp',
      ),
    ),
    'primary key' => array(
      '0' => 'id',
    ),
  );
  $data_table->meta = array(
    'join' => array(
      'node' => array(
        'left_field' => 'nid',
        'field' => 'feed_nid',
        'inner_join' => TRUE,
      ),
    ),
  );

  $export['data_table_feedapi_data_feed'] = $data_table;
  $data_table = new stdClass;
  $data_table->disabled = FALSE; /* Edit this to true to make a default data_table disabled initially */
  $data_table->api_version = 1;
  $data_table->title = 'Tags';
  $data_table->name = 'data_table_tags';
  $data_table->table_schema = array(
    'fields' => array(
      'id' => array(
        'type' => 'int',
        'size' => 'normal',
        'unsigned' => TRUE,
      ),
      'tag' => array(
        'type' => 'varchar',
        'size' => 'normal',
        'length' => 255,
      ),
    ),
    'indexes' => array(
      'id' => array(
        '0' => 'id',
      ),
    ),
    'primary key' => array(),
  );
  $data_table->meta = array(
    'fields' => array(
      'id' => array(
        'label' => 'Feed item id',
      ),
      'tag' => array(
        'label' => 'Tag',
      ),
    ),
    'join' => array(
      'data_table_feedapi_data_feed' => array(
        'left_field' => 'id',
        'field' => 'id',
        'inner_join' => '0',
      ),
    ),
  );

  $export['data_table_tags'] = $data_table;
  return $export;
}

/**
 * Helper to implementation of hook_feedapi_mapper_default().
 */
function _feedapi_data_test_feedapi_mapper_default() {
  $export = array();
  $feedapi_mapper = new stdClass;
  $feedapi_mapper->disabled = FALSE; /* Edit this to true to make a default feedapi_mapper disabled initially */
  $feedapi_mapper->api_version = 1;
  $feedapi_mapper->param = 'data_feed';
  $feedapi_mapper->mapping = array(
    'a:1:{i:0;s:5:"title";}' => 'a:2:{i:0;s:12:"feedapi_data";i:1;s:5:"title";}',
    'a:1:{i:0;s:11:"description";}' => 'a:2:{i:0;s:12:"feedapi_data";i:1;s:11:"description";}',
    'a:2:{i:0;s:7:"options";i:1;s:12:"original_url";}' => 'a:2:{i:0;s:12:"feedapi_data";i:1;s:20:"options_original_url";}',
    'a:2:{i:0;s:7:"options";i:1;s:4:"tags";}' => 'a:3:{i:0;s:12:"feedapi_data";i:1;s:20:"join:data_table_tags";i:2;s:3:"tag";}',
  );
  $feedapi_mapper->unique_elements = array(
    'a:1:{i:0;s:5:"title";}' => FALSE,
    'a:1:{i:0;s:11:"description";}' => FALSE,
    'a:2:{i:0;s:7:"options";i:1;s:12:"original_url";}' => TRUE,
    'a:2:{i:0;s:7:"options";i:1;s:4:"tags";}' => FALSE,
  );

  $export['data_feed'] = $feedapi_mapper;
  return $export;
}
